#/bin/sh
#Threshold plugin 1.1 for cacti 8.5a
#
# Copyright 2004 Aurelio DeSimone
# adesimone@ciscoconfigbuilder.com
#
# Use at your own risk.  NO Warranty or Guarantee given.
#
# Some code may have been used from other parts of cacti - copyright of Ian Berry
#

#define variables
cactibasedir=/var/www/html/cacti
rootdir=$cactibasedir/thold
httpurl=http://$HOSTNAME/cacti
logdir=/var/log
elementcache="$rootdir/state"

lookup=$cactibasedir/include/config.php

cactidbname=`grep database_default $lookup | awk -F '"' '{print $2}'`
cacti_database_username=`grep database_username $lookup | awk -F '"' '{print $2}'`
cacti_database_password=`grep database_password $lookup | awk -F '"' '{print $2}'`



#extract email destination from database
emailadd=`mysql  --user=$cacti_database_username --password=$cacti_database_password --skip-column-names -t cacti < $rootdir/tholdset.sql | grep -v + | awk '{print $4}'`
logset=`mysql  --user=$cacti_database_username --password=$cacti_database_password --skip-column-names -t cacti < $rootdir/tholdset.sql | grep -v + | awk '{print $9}'`
#extract data from database
mysql --user=$cacti_database_username --password=$cacti_database_password --skip-column-names -t cacti < $rootdir/read.sql | grep -v + > $rootdir/buffer.txt
#clean up buffer
replace "|" ":" -- $rootdir/buffer.txt
replace " " "" -- $rootdir/buffer.txt
# begin new sql update file w/ time stamp
echo "UPDATE tholdset SET datet=NOW() WHERE id='1';" > $rootdir/updates.sql

for a in `cat $rootdir/buffer.txt`
do
#parse data
element=`echo $a | awk -F ":" '{print $3}'`
elementip=`echo $a | awk -F ":" '{print $4}'`
elementid=`echo $a | awk -F ":" '{print $5}'`
threshld=`echo $a | awk -F ":" '{print $6}' | awk '{print $1}'`
rra=`echo $a | awk -F ":" '{print $7}' | awk '{print $1}'`
trigger=`echo $a | awk -F ":" '{print $9}' | awk '{print $1}'`
currentval=`grep _$rra.rrd $logdir/cacti.log | awk -F : '{print $NF}' | awk '{printf("%d\n",$1 + 0.5);}'`
if [ -f $elementcache/$rra.txt ]
        then
         echo "ok" > /dev/null 
        else
         echo "0" > $elementcache/$rra.txt
fi

alertstat=`cat $elementcache/$rra.txt | awk -F ":" '{print $1}'`
triggerct=`cat $elementcache/$rra.txt | awk -F ":" '{print $2}'`

if [ $currentval -gt $threshld ]
        then
                if [ $alertstat -eq 1 ]
                        then
				if [ $logset -eq 1 ]
					then
			                        logger "$element exceeded $threshld with $currentval at trigger $trigger out of $triggerct"
					else
						echo "logger off" > /dev/null
				fi
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
			newtrigger=`expr $triggerct + 1`
			if [ $trigger -eq $newtrigger ]
                                then
					echo "$httpurl/cactistoric.php?local_graph_id=$elementid&rra_id=1" > $rootdir/mailout.txt
                                        mail -s "$element exceeded threshold of $threshld with $currentval" $emailadd < $rootdir/mailout.txt
                        fi
			echo "1:$newtrigger" > $elementcache/$rra.txt
                else
				if [ $logset -eq 1 ]
					then
						logger "$element exceeded $threshld with $currentval at trigger $trigger out of $triggerct"
					else
						echo "logger off" > /dev/null
				fi
			newtrigger=`expr $triggerct + 1`
			if [ $trigger -eq $newtrigger ]
				then
					echo "$httpurl/cactistoric.php?local_graph_id=$elementid&rra_id=1" > $rootdir/mailout.txt
		                        mail -s "$element exceeded threshold of $threshld with $currentval" $emailadd < $rootdir/mailout.txt
			fi
			echo "UPDATE thold SET ipadd='1' WHERE rra='$rra';" >> $rootdir/updates.sql
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
                        echo "1:1" > $elementcache/$rra.txt
                fi

        else
                if [ $alertstat -eq 1 ]
                        then
                                if [ $logset -eq 1 ]
                                        then
                                                logger "$element exceeded $threshld with $currentval at trigger $trigger out of $triggerct"
                                        else
                                                echo "logger off" > /dev/null
                                fi
                        if [ $triggerct -gt $trigger ] || [ $triggerct -eq $trigger ]
				then
					mail -s "$element fell below threshold of $threshld with $currentval" $emailadd < $elementcache/$rra.txt
			fi
                        echo "0:0" > $elementcache/$rra.txt
			echo "UPDATE thold SET ipadd='0' WHERE rra='$rra';" >> $rootdir/updates.sql
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
                else
                        echo "0:0" > $elementcache/$rra.txt
			echo "UPDATE thold SET ipadd='0' WHERE rra='$rra';" >> $rootdir/updates.sql
			echo "UPDATE thold SET lastread='$currentval' WHERE rra='$rra';" >> $rootdir/updates.sql
                fi
fi
done

#update states
#echo "UPDATE tholdset SET datet=NOW() WHERE id='1';" >> $rootdir/updates.sql
mysql cacti < $rootdir/updates.sql

#cleanup
rm -rf $rootdir/updates.sql
rm -rf $rootdir/buffer.txt
rm -rf $rootdir/mailout.txt
