#/bin/sh
# Threshold plugin 1.0 for cacti 8.5a
#
# Copyright 2004 Aurelio DeSimone
# adesimone@ciscoconfigbuilder.com
# 
# Use at your own risk.  NO Warranty or Guarantee given.
#
# Some code may have been used from other parts of cacti - copyright of Ian Berry
#

#define some stuff
if [ "$1" != "" ]
        then
		if [ -f "$1/thold.php" ]
			then
			echo "Directory Check OK"
		else
			echo "Error - old version not found.  Please check syntax"
			exit
		fi
                echo "Installing into $1"
        else
                echo "Error - wrong syntax - you must specify cacti root directory ie: install.sh /var/www/html/cacti"
                exit
fi

#replace "/var/www/html/cacti" "$1" -- check-thold.sh

# make sure we are launched in coreect directory
#pwd=`pwd`

#if [ "$pwd" == "$1/thold" ]
#	then
#		echo "Directory check ok"
#	else
#		echo "Directory check failed.  Please make sure you are launching script from $1/thold"
#		exit
#fi


# make sure we aren't installing twice
checkold=`grep "Threshold plugin 1.1" $1 | wc -l | awk '{print $1}'`

if [ $checkold -eq 0 ]
	then
		echo "This is a new install.."
	else
		echo "An installation seems already be present.  Quitting"
		exit
fi




cactibasedir=$1
#cactidbname=cacti

lookup=$cactibasedir/include/config.php

cactidbname=`grep database_default $lookup | awk -F '"' '{print $2}'`
database_username=`grep database_username $lookup | awk -F '"' '{print $2}'`
database_password=`grep database_password $lookup | awk -F '"' '{print $2}'`

#mysql check
echo "show tables;" > quit.txt
checkdbconn=`mysql $cactidbname --user=$database_username --password=$database_password  < quit.txt | grep host_template_snmp_query | wc -l | awk '{print $1}'`
if [ $checkdbconn -eq 1 ]
        then
                echo "DB login OK"
        else
                if [ "$2" == "" ]
                        then
                                echo "Database login failed.  Please specify cacti database login - i.e. install.sh /var/www/html/cacti cactiuer cactipass"
				exit
                        else
                                echo "database username and pass given"
                                checkdbagain=`mysql $cactidbname --user=$2 --password=$3 < quit.txt | grep host_template_snmp_query | wc -l | awk '{print $1}'`
                                if [ $checkdbagain -eq 1 ]
                                        then
                                                echo "DB login OK"
						database_username=$2
						database_password=$3
                                        else
						echo "**************************************************************"
                                                echo "WARNING: - Database login still failed - "
                                                echo "You will have to update DB manually 'mysql cacti < upgrade.sql"
						echo "**************************************************************"
                                fi
                fi
fi
rm -rf quit.txt

echo " "
echo "WARNING: you may want to backup files & cacti database before proceeding."
echo "An uninstall script is provided to remove & restore modified files."
echo "Use at your own risk.  NO Warranty or Guarantee given."
echo "If you continue, you agree not to hold me liable for damages or loss of data."
echo "press CTRL+C in the next 5 seconds to stop"
sleep 6
echo " "

# backup first
echo "Backing up files..."
mv $cactibasedir/thold.php $cactibasedir/thold.php.bak
mv $cactibasedir/listthold.php $cactibasedir/listthold.php.bak
mv $cactibasedir/thold/check-thold.sh $cactibasedir/thold/check-thold.sh.bak

# modify files
echo "Modifying files..."
#replace "127.0.0.1" "$HOSTNAME" -- check-thold.sh
replace "/var/www/html/cacti" "$1" -- check-thold.sh

# add table
echo "Adding SQL tables..."
echo "
ALTER TABLE tholdset ADD COLUMN logset int(1) default '0';
ALTER TABLE thold ADD COLUMN trigger int(11) default '1';" > upgrade.sql

mysql $cactidbname --user=$database_username --password=$database_password < upgrade.sql

# install files
echo "Installing new files..."
mv thold.php $cactibasedir/
mv listthold.php $cactibasedir/
mv check-thold.sh $cactibasedir/thold/


echo "*************************************************************************************************** "
echo " "
echo "installation complete."
echo " "
echo "**************************************************************************************************** "
